-- get the addon namespace
local addon, ns = ...
-- get the config values
local cfg = ns.cfg
-- holder for some lib functions
local lib = _G["HEDD_lib"] or CreateFrame("Frame","HEDD_lib")
ns.lib = lib

--[[lib.CD_OnEvent = function(self, event, ...)
	if event~="SPELL_UPDATE_COOLDOWN" then return end
	local start, duration = GetSpellCooldown(self.spellID)
    if duration > 0 then
		CooldownFrame_SetTimer(self.cooldown,start, duration,1)
    else
        self.cooldown:Hide()
    end
end]]

local btn
lib.UpdateCD=function(spell)
	btn=_G["HEDD_CD_"..spell]
	if btn then
		if cfg.spells[spell].cd>0 then
			CooldownFrame_SetTimer(btn.cooldown,cfg.spells[spell].start, cfg.spells[spell].cd,1)
		else
			btn.cooldown:Hide()
		end
	end
end

cd_old={}
lib.CD_OnEventItem = function(self, event, ...)
	hedlib.shallowCopy(self,cd_old)
	self.start, self.duration, self.enable = GetItemCooldown(self.itemID)
	if not hedlib.ArrayNotChanged(self,cd_old) then return end
	if enable == 0 then
		hedlib.SetDesaturation(self.icon,1)
--		print("Disabled")
		return
	end
	hedlib.SetDesaturation(self.icon,nil)
    if self.duration > 0 then
		self.cooldown:Show()
        self.cooldown:SetCooldown(self.start, self.duration)
    else
        self.cooldown:Hide()
    end
end

lib.CDadd = function(spell,ids,addtimer,state)
	if not cfg.spells[spell] then return end
	if not HeddDB.CD[cfg.spells[spell].id] then
		HeddDB.CD[cfg.spells[spell].id]={}
		HeddDB.CD[cfg.spells[spell].id].enabled=true
		HeddDB.CD[cfg.spells[spell].id].hide=false
	end
	
	if not HeddDB.CD[cfg.spells[spell].id].hide then
		local btn = _G["HEDD_CD_"..spell] or CreateFrame("Button", "HEDD_CD_"..spell, Heddframe.CD, "SecureActionButtonTemplate,ActionButtonTemplate")
		if btn and not InCombatLockdown() then
			btn:Show()
		end
		btn.spell=spell
		btn.spellID=cfg.spells[spell].id
		lib.FrameResize(btn,HeddDB.cdsize or cfg.cdsize)
		btn:SetAttribute("*type1", "spell")
		btn:SetAttribute("spell", cfg.spells[spell].name)
		btn:RegisterForClicks("AnyUp")
		btn.icon:SetTexture(cfg.spells[spell].icon)
		btn:ClearAllPoints()
		if not cfg.cd_num then
			btn:SetPoint("TOP",Heddframe.CD,"BOTTOM")
			cfg.cd_num=1
		else
			cfg.cd_num=cfg.cd_num+1
			btn:SetPoint("LEFT",("HEDD_CD_"..cfg.cd_last),"RIGHT",10,0)
		end
		cfg.cd_last=spell

		local cd = _G["HEDD_CD_"..spell.."Cooldown"] or CreateFrame("Cooldown", "$parentCooldown", btn, "CooldownFrameTemplate")
		cd:SetAllPoints(true)
		cd:SetFrameLevel(4)
		cd:Hide()
		btn.cooldown=cd

		local shine = _G["HEDD_CD_"..spell.."Shine"] or CreateFrame("FRAME", "$parentShine", btn, "SpellBookShineTemplate") --"SpellBookShineTemplate,AutoCastShineTemplate")
		shine:SetFrameStrata("MEDIUM")
		shine:SetFrameLevel(5)
		shine:SetAllPoints(true)
		btn.shine=shine
		AutoCastShine_AutoCastStart(btn.shine)
		
		if HeddDB.CD[btn.spellID].enabled then btn.shine:Show()
		else btn.shine:Hide() end

		lib.UpdateCD(spell)
		btn:SetScript("PostClick", function(self, button)
			if button~="LeftButton" then 
				lib.CDtoggle(spell)
			end
		end)
		if ids then btn.ids = ids end
		btn.timers={}
		if addtimer or cfg.aura[spell] then
			lib.CDaddTimers(spell,spell,"aura")
			if cfg.aura[spell.."_stacks"] then
				lib.CDaddStacks(spell,spell.."_stacks")
			end
		elseif cfg.auras[spell] then
			lib.CDaddTimers(spell,spell,"auras")
		end
		if state then
			if state=="turnoff" then
				lib.CDturnoff(spell)
			end
			if state=="on" then
				lib.CDtoggleOn(spell)
			end
			if state=="off" then
				lib.CDtoggleOff(spell)
			end
		end
	end
	if not _G[Heddframe.OptionsPanel:GetName().."_cd_"..spell] or not _G[Heddframe.OptionsPanel:GetName().."_cd_"..spell]:IsShown() then
		cfg.cd_options=lib.CDOptionsAdd(Heddframe.OptionsPanel,spell,cfg.cd_options)
	end
end

local btn
local timer
lib.CDaddTimers = function(spell,aura,func,events,lowstrata,vertex)
	btn = _G["HEDD_CD_"..spell]
	if btn then
		timer=#btn.timers+1
		btn.timers[timer]={}
		btn.timers[timer].frame=_G["HEDD_CD_"..spell.."_Timer"..timer] or CreateFrame("Frame","HEDD_CD_"..spell.."_Timer"..timer,btn)
		btn.timers[timer].frame:SetFrameStrata("MEDIUM")
		if lowstrata then
			btn.timers[timer].frame:SetFrameLevel(10)
		else
			btn.timers[timer].frame:SetFrameLevel(20+timer)
		end
		btn.timers[timer].frame:SetAllPoints(true)
		btn.timers[timer].frame.cooldown = _G["HEDD_CD_"..spell.."_Timer"..timer.."_Cooldown"] or CreateFrame("Cooldown", "$parent_Cooldown", btn.timers[timer].frame, "CooldownFrameTemplate")
		btn.timers[timer].frame.cooldown:SetAllPoints(true)
		btn.timers[timer].frame.cooldown:Hide()
		btn.timers[timer].frame.cooldown.icon=_G["HEDD_CD_"..spell.."_Timer"..timer.."_Texture"] or btn.timers[timer].frame:CreateTexture("HEDD_CD_"..spell.."_Timer"..timer.."_Texture","BACKGROUND")
		btn.timers[timer].frame.cooldown.icon:SetAllPoints(btn.timers[timer].frame)
		if cfg.spells[aura] then
			btn.timers[timer].frame.cooldown.icon:SetTexture(lib.GetSpellIcon(aura))
		else
			btn.timers[timer].frame.cooldown.icon:SetTexture(lib.GetAuraIcon(aura))
		end
		if vertex then
			btn.timers[timer].frame.cooldown.icon:SetVertexColor(unpack(vertex))
			hedlib.CreateBD(btn.timers[timer].frame,cfg.cdborder,vertex)
		else
			btn.timers[timer].frame.cooldown.icon:SetVertexColor(1,0,0)
			hedlib.CreateBD(btn.timers[timer].frame,cfg.cdborder,{1,0,0,1})
		end
		btn.timers[timer].frame.cooldown.icon:Hide()
		btn.timers[timer].frame.cooldown.btn=btn

		btn.timers[timer].frame.bd:Hide()
		btn.timers[timer].frame.cooldown.bd=btn.timers[timer].frame.bd
		btn.timers[timer].frame.cooldown:HookScript("OnShow", function(self)
		self.btn.icon:Hide()
		self.bd:Show()
		self.icon:Show()
		end)
		btn.timers[timer].frame.cooldown:HookScript("OnHide", function(self)
		self.btn.icon:Show()
		self.bd:Hide()
		self.icon:Hide()
		lib.UpdateCD(self.btn.spell)
		end)
		if func then
			if func=="aura" then
				if cfg.aura[aura] then
					cfg.aura[aura].cd=cfg.aura[aura].cd or {}
					cfg.aura[aura].cd["apply_"..lib.SetAuraFunction(aura,"OnApply",function(num_func)
						CooldownFrame_SetTimer(cfg.aura[aura].cd["apply_"..num_func],cfg.aura[aura].expire-cfg.aura[aura].duration,cfg.aura[aura].duration,1)
					end)]=btn.timers[timer].frame.cooldown
					cfg.aura[aura].cd["fade_"..lib.SetAuraFunction(aura,"OnFade",function(num_func)
						CooldownFrame_SetTimer(cfg.aura[aura].cd["fade_"..num_func],cfg.aura[aura].expire-cfg.aura[aura].duration,cfg.aura[aura].duration,1)
					end)]=btn.timers[timer].frame.cooldown
				end
			elseif func=="auras" then
				if cfg.auras[aura] then
					for _,n_aura in ipairs(cfg.auras[aura]) do
						cfg.aura[n_aura].cd=cfg.aura[n_aura].cd or {}
						cfg.aura[n_aura].cd["apply_"..lib.SetAuraFunction(n_aura,"OnApply",function(num_func)
							cfg.aura[n_aura].cd["apply_"..num_func].icon:SetTexture(lib.GetAuraIcon(n_aura))
							CooldownFrame_SetTimer(cfg.aura[n_aura].cd["apply_"..num_func],cfg.aura[n_aura].expire-cfg.aura[n_aura].duration,cfg.aura[n_aura].duration,1)
						end)]=btn.timers[timer].frame.cooldown
						cfg.aura[n_aura].cd["fade_"..lib.SetAuraFunction(n_aura,"OnFade",function(num_func)
							CooldownFrame_SetTimer(cfg.aura[n_aura].cd["fade_"..num_func],cfg.aura[n_aura].expire-cfg.aura[n_aura].duration,cfg.aura[n_aura].duration,1)
						end)]=btn.timers[timer].frame.cooldown
					end
				end
			else
				btn.timers[timer].frame:SetScript("OnEvent", func)
				if events then
					for _, value in ipairs(events) do
						btn.timers[timer].frame:RegisterEvent(value)
					end
				end
			end
		end
	end
end



lib.CDaddStacks = function(spell,func,events)
	local btn = _G["HEDD_CD_"..spell]
	if btn then
		btn.text = btn.text or hedlib.CreateFont(btn, cfg.textfont, HeddDB.tsize-2, "OUTLINE")
		btn.text:SetPoint("BOTTOMRIGHT",btn,"BOTTOMRIGHT")
		btn.text:SetText("")
		if func then
			if type(func)=="string" then
				cfg.aura[func].cd_stacks=btn.text
				lib.SetAuraFunction(func,"OnStacks",function()
					cfg.aura[func].cd_stacks:SetText(cfg.aura[func].stacks>0 and cfg.aura[func].stacks or "")
				end)
			else
				btn:HookScript("OnEvent", func)
				if events then
					for _, value in ipairs(events) do
						btn:RegisterEvent(value)
					end
				end
			end
		end
	end
end


lib.Itemadd = function(item)
	if not item then return nil end
	local texture=select(10,GetItemInfo(item))
	if not texture then return nil end
	
	local btn = _G["HEDD_CD_"..item] or CreateFrame("Button", "HEDD_CD_"..item, Heddframe.CD, "SecureActionButtonTemplate,ActionButtonTemplate")
	btn.itemID=item
	lib.FrameResize(btn,HeddDB.cdsize or cfg.cdsize)
	btn:SetAttribute("*type1", "item")
	btn:SetAttribute("item", "item:"..item)
	btn:RegisterForClicks("AnyUp")
	btn.icon:SetTexture(texture)
	btn:ClearAllPoints()
	if not cfg.cd_num then
		btn:SetPoint("TOP",Heddframe.CD,"BOTTOM")
		cfg.cd_num=1
	else
		cfg.cd_num=cfg.cd_num+1
		btn:SetPoint("LEFT",("HEDD_CD_"..cfg.cd_last),"RIGHT",10,0)
	end
	cfg.cd_last=item
	
	
	local cd = _G["HEDD_CD_"..item.."Cooldown"] or CreateFrame("Cooldown", "$parentCooldown", btn, "CooldownFrameTemplate")
	cd:SetAllPoints(true)
	cd:SetFrameLevel(4)
	cd:Hide()
	btn.cooldown=cd
	btn:Show()
	btn:RegisterEvent("SPELL_UPDATE_COOLDOWN")
	btn:RegisterEvent("PLAYER_REGEN_ENABLED")
	btn:SetScript("OnEvent", lib.CD_OnEventItem)
	lib.CD_OnEventItem(btn)
end

lib.CDturnoff = function(spell)
	if not cfg.spells[spell] then return end
	local btn = _G["HEDD_CD_"..spell]
	if btn then
		btn.shine:Hide()
		lib.CDDisable(btn.spellID)
		if btn.ids then
			for _, value in ipairs(btn.ids) do
				lib.CDDisable(value)
			end
		end
		cfg.Update=true
		btn:SetScript("PostClick",nil)
	end
end

lib.CDtoggleOn = function(spell)
	if not cfg.spells[spell] then return end
	local btn = _G["HEDD_CD_"..spell]
	if btn then
		btn.shine:Show()
		lib.CDEnable(btn.spellID)
		if btn.ids then
			for _, value in ipairs(btn.ids) do
				lib.CDEnable(value)
			end
		end
		cfg.Update=true
		btn:SetScript("PostClick", function(self, button)
			if button~="LeftButton" then 
				lib.CDtoggle(spell)
			end
		end)
	end
end

lib.CDtoggleOff = function(spell)
	if not cfg.spells[spell] then return end
	local btn = _G["HEDD_CD_"..spell]
	if btn then
		btn.shine:Hide()
		lib.CDDisable(btn.spellID)
		if btn.ids then
			for _, value in ipairs(btn.ids) do
				lib.CDDisable(value)
			end
		end
		cfg.Update=true
		btn:SetScript("PostClick", function(self, button)
			if button~="LeftButton" then 
				lib.CDtoggle(spell)
			end
		end)
	end
end

lib.CDtoggle = function(spell)
	if not cfg.spells[spell] then return end
	local btn = _G["HEDD_CD_"..spell]
	if btn then
		if HeddDB.CD[btn.spellID].enabled then
			btn.shine:Hide()
			lib.CDDisable(btn.spellID)
			if btn.ids then
				for _, value in ipairs(btn.ids) do
					lib.CDDisable(value)
				end
			end
			cfg.Update=true
		else
			btn.shine:Show()
			lib.CDEnable(btn.spellID)
			if btn.ids then
				for _, value in ipairs(btn.ids) do
					lib.CDEnable(value)
				end
			end
			cfg.Update=true
		end
	end
end

lib.CDdel = function(spell)
	local btn=_G["HEDD_CD_"..spell]
	if btn and not InCombatLockdown() then
		btn:Hide()
	end
end

lib.CDDelAll = function()
	for index,name in pairs(cfg.spells) do
		lib.CDdel(index)
	end
	cfg.cd_num=nil
	cfg.cd_last=nil
end

lib.CDOptionsAdd = function(f,spell,position)
	if cfg.spells[spell] then
		local cd=lib.AddIconButton(f,f:GetName().."_cd_"..spell,cfg.isize,cfg.spells[spell].id,"OVERLAY")
		cd:SetPoint("BOTTOMLEFT", f,"BOTTOMLEFT",cfg.options_shift+(position*(cfg.isize+5)),cfg.options_shift)
		cd:Show()
		cd.id=cfg.spells[spell].id
		hedlib.CreateTexture(cd,"hiding","OVERLAY",nil,1)
		cd.hiding:SetTexture(135/255,206/255,235/255,0.5)
		if HeddDB.CD[cd.id].hide then
			cd.hiding:Show()
		else
			cd.hiding:Hide()
		end
		cd:EnableMouse(true)
		cd:RegisterForClicks("AnyUp")
		cd:SetScript("OnClick", function (self, button, down)
		if HeddDB.CD[self.id].hide then
			HeddDB.CD[self.id].hide=false
			self.hiding:Hide()
		else
			HeddDB.CD[self.id].hide=true
			self.hiding:Show()
		end
		lib.CDRefresh()
		end);
		position=position+1
	end
	return position
end

lib.CDOptionsAddAll = function(f)
	local position=0
	for spell,name in pairs(cfg.spells) do
		position=lib.CDOptionsAdd(f,spell,position)
	end
end

lib.CDOptionsHide = function(spell)
	local btn=_G[Heddframe.OptionsPanel:GetName().."_cd_"..spell]
	if btn then
		btn:Hide()
	end
end

lib.CDOptionsHideAll = function(f)
	for spell,name in pairs(cfg.spells) do
		lib.CDOptionsHide(spell)
	end
end

lib.CDOptionsUncheckAll = function()
	for spell,name in pairs(cfg.spells) do
		local btn=_G[Heddframe.OptionsPanel:GetName().."_cd_"..spell]
		if btn then
			btn.hiding:Hide()
		end
	end
end

lib.CDresize = function(spell)
	local btn=_G["HEDD_CD_"..spell]
	if btn then
		lib.FrameResize(btn,HeddDB.cdsize or cfg.cdsize)
	end
end

lib.CDEnable = function(id)
	if not HeddDB.CD[id] then
		HeddDB.CD[id]={}
		HeddDB.CD[id].hide=false
	end
	HeddDB.CD[id].enabled=true
end

lib.CDDisable = function(id)
	if not HeddDB.CD[id] then
		HeddDB.CD[id]={}
		HeddDB.CD[id].hide=false
	end
	HeddDB.CD[id].enabled=false
end

lib.CDShow = function(id)
	if HeddDB.CD[id] then
		HeddDB.CD[id].hide=false
	end
end

lib.CDShowAll = function()
	for index,name in pairs(cfg.spells) do
		lib.CDShow(cfg.spells[index].id)
	end
end

lib.CDRefresh = function()
	lib.CDDelAll()
	if lib.CD then lib.CD() end
end
